#!/bin/bash
#
# Einfacher Zeilen-Editor

function show {
  for i in $( seq 0 $lines ); do
    printf "%3d: " $i 
    echo "${tmp_doc[i]}"
  done
}

function fehler {
  echo "$0: Fehler: $1"
  exit 1
}

# Test auf Fehler: Kein Dateiname (oder zu viele Argumente)
if [ $# -ne 1 ]; then
  fehler "Aufruf: $0 filename."
fi

filename=$1

# Test auf Fehler: Datei nicht vorhanden
if [ ! -f $filename ]; then
  fehler "Datei \"$filename\" existiert nicht."
fi

lines=$( wc -l < $filename )         # Anzahl Zeilen

for i in $( seq 0 $lines ); do
  read -r; tmp_doc[$i]="$REPLY"      # zeilenweise einlesen
done < $filename
show

while true; do
  echo -n "Zeilennummer oder 'wq', 'q!' oder 'show' eingeben: "
  read linenumber
  if [ "Z$linenumber" == "Z" ]; then
    continue
  fi
  if [ $linenumber == "q!" ]; then
    break
  fi
  if [ $linenumber == "wq" ]; then
    for i in $( seq 0 $lines ); do
      printf "%s\n" "${tmp_doc[i]}"
    done > tmp.out
    break
  fi
  if [ $linenumber == "show" ]; then
    show
    continue
  fi
  
  # Pruefen, ob Eingabe eine Zahl ist
  zahlen='^[0-9]+$'
  if ! [[ $linenumber =~ $zahlen ]] ; then
    echo "Fehler: Weder Zeilennummer noch Editor-Kommando"
    continue
  fi
  
  # Pruefen, ob Zeilennummer gueltig
  if [ $linenumber -gt $lines ]; then
    echo "Fehler: Zeile" $linenumber "existiert nicht."
    continue
  fi
  
  echo Ersetze Zeile $linenumber
  ## printf "%3d: " $linenumber
  ## echo "${tmp_doc[linenumber]}"
  ## printf "%3d: " $linenumber
  ## read; tmp_doc[$linenumber]="$REPLY"
  # ./editline "${tmp_doc[linenumber]}" 2> .newline
  ./editline2 "${tmp_doc[linenumber]}" 2> .newline
  read -r < .newline; tmp_doc[$linenumber]="$REPLY"
  rm -f .newline
  echo Zeile $linenumber ersetzt.
done
